//+------------------------------------------------------------------+
//|                                           MultiMovingAverage.mq4 |
//+------------------------------------------------------------------+
#property copyright "Ron T"
#property link      "http://www.lightpatch.com"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Aqua
#property indicator_color2 Silver
#property indicator_color3 Gold
#property indicator_color4 Magenta
#property indicator_color5 Magenta
#property indicator_color6 BlueViolet
#property indicator_color7 BlueViolet
#property indicator_color8 Lime

#define NR1          10

//---- buffers
double VolBuffer1[];
double VolBuffer2[];
double VolBuffer3[];
double VolBuffer4[];//10Y Bond Open
double VolBuffer5[];//10Y Bond Low-High
double VolBuffer6[];//30Y Bond Open
double VolBuffer7[];//30Y Bond Low-High
double VolBuffer8[];//

//"^TNX",5.118,"6/8/2007","2:59pm",+0.019,5.162,5.181,5.105,0
//"^TYX",5.22,"6/8/2007","2:59pm",+0.017,5.27,5.284,5.21,0

string b10[NR1][9];
string b30[NR1][9];
                    
string       CalName1;

int init()
  {

//ArrayInitialize(b10,"");
//ArrayInitialize(b30,"");
/////////////////////////////////////////////////////////////////////////////////////
//0-Symbol,   1-Index Value,   2,3-Trade time, 4-Change,  5-Open, 6-High, 7-Low, 8-0
/////////////////////////////////////////////////////////////////////////////////////
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
b10[0][9]= {"^TNX","5.118","6/8/2007","2:59pm","+0.019","5.162","5.181","5.105","0"};

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
b30[0][9]= {"^TYX","5.22","6/8/2007","2:59pm","+0.017","5.27","5.284","5.21","0"};


/////////////////////////////////////////////////////////////////////////////////////

   
   IndicatorBuffers(8);
   SetIndexStyle(0,DRAW_LINE,0,2);//DJ
   SetIndexBuffer(0, VolBuffer1);
   SetIndexStyle(1,DRAW_LINE,0,2);//CL
   SetIndexBuffer(1, VolBuffer2);
   SetIndexStyle(2,DRAW_LINE,0,2);//Gold
   SetIndexBuffer(2, VolBuffer3);   
   SetIndexStyle(3,DRAW_LINE,1,1);//Y10
   SetIndexBuffer(3, VolBuffer4);      
   SetIndexStyle(4,DRAW_HISTOGRAM,1,1);//Y10
   SetIndexBuffer(4, VolBuffer5);      
   SetIndexStyle(5,DRAW_LINE,1,1);//Y30
   SetIndexBuffer(5, VolBuffer6);      
   SetIndexStyle(6,DRAW_HISTOGRAM,1,1);//Y30
   SetIndexBuffer(6, VolBuffer7);      
   SetIndexStyle(7,DRAW_HISTOGRAM,1,1);
   SetIndexBuffer(7, VolBuffer8);      


   return(0);
  }


//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
/*  
   int i;
   
   for( i=0; i<Bars; i++ ) VolBuffer1[i]=0;

   return(0);
*/   
  }

/*
     int pos1 = iBarShift("GOLD", 0, iTime(NULL,0,x), true);
		if (iTime("GOLD", 0, pos1) == iTime(NULL,0,x))  // have to be sure the times match.
		{
		 	open8[x]=iVolume("GOLD",0,pos1)/const1();//1*0.25*l1;   
		}
		else
		{
			open8[x]=0;//1*0.25*l1;   
		}
*/

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//calc_date_time("11/8/2007", "2:59pm");
   
   double curTYP=0;
   double oldTYP=0;
   double change=0;
   
   double x1,x2,x3;

   int pos=Bars;///4;
  
   // Print ("Start SHOW5TICKS with bars=",pos);
   //string rec1[9];
   //ArrayInitialize(rec1,0);
   //string ss1=readfield(3*9);
   //Print(ss1);
   while(pos>=0)
     {
      //VolBuffer1[pos]=iClose("DOWJONES",0,pos);//Close[pos];
      int pos1 = iBarShift("DOWJONES", 0, iTime(NULL,0,pos), false);
		if (iTime("DOWJONES", 0, pos1) == iTime(NULL,0,pos))  // have to be sure the times match.
		{ x1=5*(iClose("DOWJONES",0,pos1)/100);
		  VolBuffer1[pos]=x1/10;//1*0.25*l1;   
		}
		else
		{
		//	VolBuffer1[pos]=x1;//1*0.25*l1;   
		}

      //VolBuffer1[pos]=iClose("GOLD",0,pos);//Close[pos];
      int pos2 = iBarShift("CRUDEOIL", 0, iTime(NULL,0,pos), false);
		if (iTime("CRUDEOIL", 0, pos2) == iTime(NULL,0,pos))  // have to be sure the times match.
		{ x2=iClose("CRUDEOIL",0,pos2);
		    
		 	   VolBuffer2[pos]=x2;//1*0.25*l1;   
		}
		else
		{
			//VolBuffer2[pos]=x2;//1*0.25*l1;   
		}

     //VolBuffer1[pos]=iClose("GOLD",0,pos);//Close[pos];
      int pos3 = iBarShift("F-Gold", 0, iTime(NULL,0,pos), false);
		if (iTime("F-Gold", 0, pos3) == iTime(NULL,0,pos))  // have to be sure the times match.
		{ x3=iClose("F-Gold",0,pos3);
		    
		 	   VolBuffer3[pos]=x3/10;//1*0.25*l1;   
		}
		else
		{
			//VolBuffer2[pos]=x2;//1*0.25*l1;   
		}

 	   pos--;
     }
 /*    
   int i;
   
   for( i=0; i<Bars; i++ ) VolBuffer1[i]=1;
*/   
   
   return(0);
  }
//+------------------------------------------------------------------+
string datebondstr(string date1,string hour)
{
  string hour1;
  string h1;
  int p1;
  if(StringFind(hour,"am",0)<0)//pm
  {
    p1=StringFind(hour,":",0);
    if (p1==1)
       h1=StringSubstr(hour,0,1);
    else
       h1=StringSubstr(hour,0,2);        
       //"6/11/2007","2:59pm"
       hour1=DoubleToStr(StrToInteger(h1)+12,0)+StringSubstr(hour,p1,StringLen(hour)-(p1+1)-1);
  }
  else//am
    hour1=hour;
  //return (hour1);
  return(TimeToStr(StrToTime(date1+" "+hour1),TIME_DATE|TIME_MINUTES));
}

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|

datetime calc_date_time(string day1, string hour1)
{
  string z1,l1,a1,h1,m1;
  // 01234567
  //"6/8/2007"
  datetime r1;
  int p1=StringFind(day1,"/",0);//p1=1
  l1=StringSubstr(day1,0,p1);
  Print("l1->",l1);
  string day2=StringSubstr(day1,p1+1,StringLen(day1)-(p1+1));
  // 012345
  //"8/2007"
  int p2=StringFind(day2,"/",0);//p2=1
  string day3=StringSubstr(day2,p2+1,StringLen(day2)-(p2+1));
  z1=StringSubstr(day2,0,p2);  
  a1=day3;  
  Print("z1->",z1);
  Print("a1->",a1);  
  
  return(r1);
}

string readfield(int nrrec)
{
   //string rec1[9];
   string StartMonth0;
   string StartDay0;
   datetime Start0 = iTime(NULL,PERIOD_D1,0);  
   string StartYear0  = TimeYear (Start0);
   if (TimeMonth(Start0)>10) 
     StartMonth0 = TimeMonth(Start0);
   else 
     StartMonth0 = "0" + TimeMonth(Start0);
     
   if (TimeDay(Start0)>10) 
     StartDay0   = TimeDay(Start0);
   else 
     StartDay0 = "0" + TimeDay(Start0);  
   
   
   CalName1 = "Bonds2_"+StartYear0+"-"+StartMonth0+"-"+StartDay0+".csv";
   
   //int handle=FileOpen(CalName1,FILE_BIN |FILE_READ,' ');
   int handle=FileOpen(CalName1,FILE_CSV |FILE_READ,',');
   string result;
   if(handle>0)
   {
      //FileSize(handle);//file size in bytes
      //FileSeek(handle, 1, SEEK_END);
      for (int i=0;i<nrrec;i++)
      {
        FileReadString(handle,result);
        
      }  
      FileClose(handle);      
   }
 return(result);  
}